'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _utils = require('./utils');

var _constants = require('../constants');

var _propTypes2 = require('prop-types');

var _propTypes3 = _interopRequireDefault(_propTypes2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var withPagination = function withPagination(WrappedComponent) {
  var _propTypes;

  var propTypes = (_propTypes = {}, _defineProperty(_propTypes, _constants.BACKEND_ACTIONS.INDEX, _propTypes3.default.shape({
    /** Pagination props */
    pagination: _propTypes3.default.shape({
      perPage: _propTypes3.default.number.isRequired,
      page: _propTypes3.default.number.isRequired
    }).isRequired
  }).isRequired), _defineProperty(_propTypes, 'apiIndexRequest', _propTypes3.default.func.isRequired), _propTypes);

  /**
   * HOC Component that wrapps actions related to vault of funnel.
   *
   * @author [César Parra](https://github.com/cparram)
   */

  var WithPagination = function (_React$Component) {
    _inherits(WithPagination, _React$Component);

    function WithPagination() {
      var _ref;

      var _temp, _this, _ret;

      _classCallCheck(this, WithPagination);

      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = WithPagination.__proto__ || Object.getPrototypeOf(WithPagination)).call.apply(_ref, [this].concat(args))), _this), _this.onPerPageChange = function (perPage) {
        var pagination = _this.props[_constants.BACKEND_ACTIONS.INDEX].pagination;
        // Get the current page

        var page = pagination.page;
        // updates current list of records (optional)
        _this.paginatable.apiReduxIndex && typeof _this.paginatable.apiReduxIndex === 'function' && _this.paginatable.apiReduxIndex(page, perPage);
      }, _this.onChangePage = function (page) {
        var pagination = _this.props[_constants.BACKEND_ACTIONS.INDEX].pagination;
        // Get the current per page value

        var perPage = pagination.perPage;
        // updates current list of records (optional)
        _this.paginatable.apiReduxIndex && typeof _this.paginatable.apiReduxIndex === 'function' && _this.paginatable.apiReduxIndex(page, perPage);
      }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    /**
     * Callback function responsible to get resources for table
     * when per page value change
     * 
     * @param {number} perPage - pagination value
     */


    /**
     * Callback function responsible to get resources for table
     * when page value change
     * 
     * @param {number} page - pagination value
     */


    _createClass(WithPagination, [{
      key: 'render',
      value: function render() {
        var _this2 = this;

        return _react2.default.createElement(WrappedComponent, _extends({
          paginatableRef: function paginatableRef(ref) {
            return _this2.paginatable = ref;
          },
          paginatable: {
            onPerPageChange: this.onPerPageChange,
            onChangePage: this.onChangePage
          }
        }, this.props));
      }
    }]);

    return WithPagination;
  }(_react2.default.Component);

  WithPagination.displayName = 'WithPagination(' + (0, _utils.getDisplayName)(WrappedComponent) + ')';
  WithPagination.propTypes = propTypes;

  return WithPagination;
};

exports.default = withPagination;